//
//  BullsEyeViewController.m
//  BullsEye
//
//  Created by chrisfarrell on 4/27/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//


#import "BullsEyeViewController.h"
#import "AboutViewController.h"
#import <QuartzCore/QuartzCore.h>

@interface BullsEyeViewController ()

@end

@implementation BullsEyeViewController{
    int currentSliderValue, targetValue, score, round;
}

@synthesize slider, target, scoreLabel, roundLabel;

#pragma mark IB actions
-(IBAction)run:(id)sender{
    int difference;
    difference = abs(currentSliderValue - targetValue);
    
    int points;
    points = 100 - difference;
    
    NSString* title;
    if (difference == 0) {
        title = [NSString stringWithFormat:@"Bullseye!"]; 
        points += 100;
    }else if(difference < 25){
        title = [NSString stringWithFormat:@"Not bad!"];
        points += 10;
    }else{
       title = [NSString stringWithFormat:@"Try harder!"]; 
       points *= -1;
    }

    
    NSString* msg = [NSString stringWithFormat:@"%d Points", points];
    score += points;
    
    UIAlertView * alert = [[UIAlertView alloc] 
                           initWithTitle:title 
                           message:msg
                           delegate:self 
                           cancelButtonTitle:@"Play" 
                           otherButtonTitles: nil
                           ];
    [alert show];
    
    
}

-(IBAction)sliderValueChanged:(UISlider *)sender{

    currentSliderValue = slider.value;

}

-(IBAction)startOver:(id)sender{
    
    CATransition* transition = [CATransition animation];
    transition.type = kCATransitionFade;
    transition.duration = 1;
    transition.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn];
    
    [self startNewGame];
    
    [self.view.layer addAnimation:transition forKey:nil];
}
-(IBAction)showInfoView:(id)sender{
    AboutViewController* aboutView = [[AboutViewController alloc] initWithNibName:@"AboutViewController" bundle:nil];
    aboutView.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
    [self presentViewController:aboutView animated:YES completion:nil];
}

#pragma mark game logic
- (void)startNewRound{
    currentSliderValue = 50;
    self.slider.value = lroundf(currentSliderValue);
    targetValue = 1 + (arc4random() % 100);
    round += 1;
    [self updateLabels];

}

- (void)updateLabels{
    self.target.text = [NSString stringWithFormat:@"%d", targetValue];
    self.scoreLabel.text = [NSString stringWithFormat:@"%d", score];
    self.roundLabel.text = [NSString stringWithFormat:@"%d", round];
}

-(void)startNewGame{
    round = 0;
    score = 0;
    [self startNewRound];
}

#pragma mark view control
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    UIImage* sliderThumbNormal = [UIImage imageNamed:@"SliderThumb-Normal"];
    UIImage* sliderThumbHighlighted = [UIImage imageNamed:@"SliderThumb-Highlighted"];
    UIImage* sliderTrackLeft = [UIImage imageNamed:@"SliderTrackLeft"];
    UIImage* sliderTrackRight = [UIImage imageNamed:@"SliderTrackRight"];
    
    [self.slider setThumbImage:sliderThumbNormal forState:UIControlStateNormal];
    [self.slider setThumbImage:sliderThumbHighlighted forState:UIControlStateHighlighted];
    [self.slider setMinimumTrackImage:sliderTrackLeft forState:UIControlStateNormal];
    [self.slider setMaximumTrackImage:sliderTrackRight forState:UIControlStateNormal];    
    
	[self startNewGame];   

}

- (void)viewDidUnload
{
    [super viewDidUnload];

    self.slider = nil;
    self.roundLabel = nil;
    self.scoreLabel = nil;
    self.target = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return UIInterfaceOrientationIsLandscape(interfaceOrientation);
}

#pragma mark alert delegate
- (void) alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex{
    [self startNewRound];
}

@end
